#include <unistd.h>
#include <stdio.h>
#include <signal.h>
#include "lcp3.h"
#include "lcp3_io.h"
#include "globals.h"

void cleanup();

void terminate()
{
    cleanup();
    close(globs->socket);
#ifdef OSD
	    xosd_uninit(osd.osd);
#endif
    exit(0);
}

void cleanup()
{
    signal(SIGINT, terminate);
    if ( !globs->first_tput ) printf("\n\n");
    switch ( globs->client )
    {
	case CLT_ONLINE:
	case CLT_OFFLINE:
	case CLT_DIALING:
	case CLT_CLOSING:
	    fprintf(stdout, "Terminating, please wait...\n");
    }
    switch ( globs->client )
    {
	case CLT_ONLINE:
	    cmd_queue(CMD3_OFFLINE, NULL, 0);
	    break;
	case CLT_OFFLINE:
	case CLT_DIALING:
	case CLT_CLOSING:
	    cmd_queue(CMD3_UNREG, NULL, 0);
	    return;
	case CLT_NOAUTH:
	    close(globs->socket);
	case CLT_DISCON:
	default:
#ifdef OSD
	    xosd_uninit(osd.osd);
#endif
	    exit(0);
    }
}
