#include <stdlib.h>
#include <stdio.h>
#include "globals.h"

struct t_opts *opts;
struct t_globs *globs;
void* inbuf;
void* outbuf;
void* packet;
struct t_lcp3_cmd* p_cmd; // the same as *packet
void* p_info;	// points after the end of p_cmd

#ifdef OSD
struct t_osd osd = { NULL, XOSD_top, "black", "fixed", 4, 0, 0 };
#endif

int globals_init()
{
    int maxsize = get_max_lcp3_pack_size();
    if ( !(opts = malloc(sizeof(struct t_opts))) )
	return(-1);
    opts->action = ACT_ONLINE; // default
    opts->name[0] = 0;
    opts->pass[0] = 0;
    opts->line = 1;
    opts->watch_up = 0;
    opts->watch_dn = 0;
    opts->intervals = 3;
    opts->istimed = 0;
    opts->stay_offline = 0;
    if ( !(globs = malloc(sizeof(struct t_globs))) )
    {
	free(opts);
	return(-1);
    }
    globs->received = 0;
    globs->line = CST_DOWN;
    globs->client = CLT_DISCON;
    globs->starting = 1;
    globs->limc_up = 0;
    globs->limc_dn = 0;
    globs->first_tput = 1;
    if ( !(inbuf = malloc(maxsize * 3)) )
    {
	free(opts);
	free(globs);
	return(-1);
    }
    if ( !(outbuf = malloc(maxsize)) )
    {
	free(opts);
	free(globs);
	free(inbuf);
	return(-1);
    }
    if ( !(packet = malloc(maxsize)) )
    {
	free(opts);
	free(globs);
	free(inbuf);
	free(outbuf);
	return(-1);
    }
    p_cmd = packet;
    p_info = ((char*)packet) + sizeof(struct t_lcp3_cmd);
#ifdef OSD
    osd.osd = xosd_init(osd.font, osd.color, osd.timeout, osd.pos, osd.offset,
			osd.shadow_offset);
	osd.line2_active_since = 0;
    if ( !osd.osd )
    {
	fprintf(stderr, "Unable to init xosd.\n");
	exit(-1);
    }
#endif
    return(0);
}
