#ifndef _LCC_GLOBALS_H
#define _LCC_GLOBALS_H

#include <time.h>
#include "lcp3.h"
#ifdef OSD
#include <xosd.h>
#endif

struct t_globs {
    int socket;
    int received;
    int line;	// status
    int client;	// status
    int starting;
    time_t prevsent;
    int limc_up;
    int limc_dn;
    int first_tput;
};

#ifdef OSD
struct t_osd {
    xosd *osd;
    xosd_pos pos;
    char *color;
    char *font;
    int timeout;
    int offset;
    int shadow_offset;
	time_t line2_active_since;
};
extern struct t_osd osd;
#endif

#define ACT_MONITOR	0
#define ACT_STATUS	1
#define ACT_ONLINE	2	// default

struct t_opts {
    int srv_ip;
    short srv_port;
    char name[LCP3_MAX_NAME_LEN+1];
    char pass[LCP3_MAX_PWD_LEN+1];
    int line;
    int action;
    int timed;
    int istimed;
    int min_up;
    int watch_up;
    int min_dn;
    int watch_dn;
    int intervals;
    int stay_offline;
    int line_id;
    int get_lines;
};

extern struct t_opts *opts;
extern struct t_globs *globs;
extern void* inbuf;
extern void* outbuf;
extern void* packet;
extern struct t_lcp3_cmd* p_cmd; // the same as *packet
extern void* p_info;	// points after the end of p_cmd

int globals_init();

#define LCC_CPR	"LineControl LCP 3.3 Client 1.0.6 by S. Fuchs 1999-2001"

#endif
