#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/socket.h>
#include <errno.h>
#include <arpa/inet.h>

#include "globals.h"
#include "init.h"
#include "lcp3_io.h"
#include "proccmd.h"

#define LCC_MAXINTV	1	// maximal time sec between loops

int main(int argc, char **argv)
{
    struct sockaddr_in saddr;
    printf("\n"LCC_CPR"\n\n");
    if ( globals_init() )
    {
	fprintf(stderr, "Not enough memory!\n\n");
	exit(-1);
    }
    if ( init() )
    {
	printf("\n");
	exit(-2);
    }
    // load options from commandline
    get_opts(argc, argv);
    // configuration done, go on.
    if ( (globs->socket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == -1 )
    {
	printf("unable to get socket (errno: %d)!\n", errno);
	exit(-3);
    }
    saddr.sin_family = AF_INET;
    saddr.sin_port = 0;
    saddr.sin_addr.s_addr = INADDR_ANY;
    if ( bind(globs->socket, (struct sockaddr*)&saddr, sizeof(struct sockaddr_in)) )
    {
	printf("could not bind() socket (errno: %d)!\n", errno);
	exit(-3);
    }
    // we have a valid socket
    lcp3_io_init(globs->socket);
    // initializing done, get a tcp connection
    saddr.sin_family = AF_INET;
    saddr.sin_port = opts->srv_port;
    saddr.sin_addr.s_addr = opts->srv_ip;
    printf("\nTCP to %s:%d... ", inet_ntoa(saddr.sin_addr), ntohs(saddr.sin_port));
    if ( connect(globs->socket, (struct sockaddr*)&saddr, sizeof(struct sockaddr_in)) )
    {
	printf("failed!\n\n");
	exit(-4);
    }
    globs->client = CLT_NOAUTH;
    printf("ok\n");
    cmd_queue(CMD3_PUBKEYREQ, NULL, 0);
    for (;;)
    {
#ifdef OSD
		if ( osd.line2_active_since - time(NULL) > 30 )
		{
			osd.line2_active_since = 0;
			xosd_display(osd.osd, 0, XOSD_string, "");
		}
#endif
        if ( !get_data() )
	{ // ok, we got a new command
		process_cmd(packet);
	}
	else
	{
	    static struct timeval tv;
	    static fd_set rfd;
	    FD_ZERO(&rfd);
	    FD_SET(globs->socket, &rfd);
	    tv.tv_sec = LCC_MAXINTV;
	    tv.tv_usec = 0;
	    proc_queue();
	    select(globs->socket+1, &rfd, NULL, NULL, &tv);
	}
	if ( time(NULL) - globs->prevsent > LCP3_CLT_TIMEOUT - LCC_MAXINTV - 4 )
	    cmd_queue(CMD3_REFRESH, NULL, 0);
    }
    //
    exit(0);
}
